package org.once.serviceChoicer;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import org.once.serviceChoicer.candidate.IUDDI;
import org.once.serviceChoicer.candidate.impl.UDDI;
import org.once.serviceChoicer.input.process.impl.Process;
import org.once.serviceChoicer.input.qos.IQoSAttrs;
import org.once.serviceChoicer.input.qos.IQoSAttr.Type;
import org.once.serviceChoicer.input.qos.impl.QoSAttrs;

public class Main {
	
	public static void main(String[] args) {
		File fbpmn = new File("./testfile/default.Bpmn");
		File dbProperties = new File("./testfile/resource.properties");

		if (!fbpmn.exists()||!dbProperties.exists()) {
			System.out.println("can not find the file.");
			return;
		}
		
		Map<String,String> map = new HashMap<String,String>();
		map.put("n406_5", "Login");
		map.put("n562_45", "Mountain");
		map.put("n359_48", "Mountain");
		map.put("n078_32","Island");
		map.put("n421_35","Island");
		map.put("n437_8","Hotel");
		map.put("n703_11","Hotel");
		map.put("n656_30","Flight");
		map.put("n671_33","Flight");
		map.put("n593_6","Pay");
		map.put("n656_9","Pay");
		
		try {
			Process process = new Process(fbpmn,map);
			process.generateProcess();
			// for test
			process.test();
			
			
			
			IUDDI uddi = new UDDI(dbProperties);
			IQoSAttrs qosAttrs = QoSAttrs.getDefInstance();
			
			ServiceChoicer c = new ServiceChoicer(process, qosAttrs, uddi);
			c.resolve();
//			
			System.out.println("---------result----------");
			System.out.println(c.getScore());
			System.out.println(c.getQoSAttrValue(Type.Price));
			System.out.println(c.getQoSAttrValue(Type.ResponseTime));
			System.out.println(c.getQoSAttrValue(Type.SuccessfulRate));
//			
			System.out.println(c.getScore(Type.Price));
			System.out.println(c.getScore(Type.ResponseTime));
			System.out.println(c.getScore(Type.SuccessfulRate));
			
			System.out.println("------------------result MAP-----------------");
			Map resultmap = c.getNodeWSDLMap();//ؽӿ
			System.out.println(resultmap.toString());
			
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
