package org.once.serviceChoicer.candidate.impl;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import org.once.serviceChoicer.candidate.ICandidate;
import org.once.serviceChoicer.candidate.IUDDI;
import org.once.serviceChoicer.exception.ServiceChoicerException;
import org.once.serviceChoicer.exception.UDDIException;
import org.once.serviceChoicer.input.process.IService;
import org.once.serviceChoicer.input.qos.IQoSAttr.Type;

import org.once.serviceChoicer.input.process.impl.Service;



/*
 * ݿַ캯
 * ֵװICandidate.
 */
public class UDDI implements IUDDI{
	private Properties pros=new Properties();
	private File file;
	
	public UDDI(File filepath) throws UDDIException{
		this.file = filepath;
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (ClassNotFoundException e) {
			throw new UDDIException(e);
		}
	}
	
	@SuppressWarnings("finally")
	private Connection getConnection() throws UDDIException {
		Connection con = null;
		InputStream temp = null;
		try {
			 temp = new FileInputStream(file);
			pros.load(temp);
		} catch (IOException e) {
			try {
				temp.close();
			}finally{
				throw new UDDIException(e);
			}
		}
		String url =pros.getProperty(Constants.DBURL);
		String user=pros.getProperty(Constants.DBUSERNAME);
		String password=pros.getProperty(Constants.DBPASSWORD);
		try {
			con = java.sql.DriverManager.getConnection(url,user,password);		
		} catch (SQLException e) {
			throw new UDDIException(e);
		}
		return con;
	}
	
	private void closeConnection(Connection con){
		try{
			if(con!=null) con.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void closePrepStmt(PreparedStatement prepStmt){
	    try{
	        if(prepStmt!=null) prepStmt.close();
	      }catch(Exception e){
	        e.printStackTrace();
	      }
	  }

	  public void closeResultSet(ResultSet rs){
	    try{
	        if(rs!=null) rs.close();
	      }catch(Exception e){
	        e.printStackTrace();
	      }
	  }
	  

	private List<ICandidate> getCandidates(String ServiceType,String serviceID) throws UDDIException{
		List<ICandidate> list = new ArrayList<ICandidate>();
		Connection con=null;
		PreparedStatement prepStmt=null;
		ResultSet rs=null;
		String str="select * from tb_service_list where service_type=\""+ServiceType+"\";";
		con = getConnection();
		try {
			prepStmt = con.prepareStatement(str);
			rs = prepStmt.executeQuery();
			while (rs.next()) {
				String name = rs.getString(2);
				Candidate c = new Candidate(ServiceType, name,serviceID);
				String description = rs.getString(4);
				if(!description.trim().isEmpty()){
					String[] descriptions = description.split(";");
					for (int i = 0; i < descriptions.length; i++) {
						String[] val = descriptions[i].split("=");
						c.attrMap.put(val[0], val[1]);
					}
				}
				// candidateмwsdlַ
				String wsdl = rs.getString(9);
				c.setWsdlAddr(wsdl);
				
				
				c.setRules(Type.Price, rs.getDouble(5), null);
				c.setRules(Type.ResponseTime, rs.getDouble(6), null);
				c.setRules(Type.Reputation, rs.getDouble(7), null);
				c.setRules(Type.SuccessfulRate, rs.getDouble(8), null);

				// Ҽ۸

				String sPrice = "Select * from tb_price where service_name=\""
						+ name + "\";";
				ResultSet rPrice = null;
				prepStmt = con.prepareStatement(sPrice);
				rPrice = prepStmt.executeQuery();
				while (rPrice.next())
					c.setRules(Type.Price, rPrice.getDouble(3), rPrice
							.getString(4));

				// ִʱ

				String sRTime = "Select * from tb_execute_time where service_name=\""
						+ name + "\";";
				ResultSet rRTime = null;
				prepStmt = con.prepareStatement(sRTime);
				rRTime = prepStmt.executeQuery();
				while (rRTime.next())
					c.setRules(Type.ResponseTime, rRTime.getDouble(3), rRTime
							.getString(4));

				// 

				String sRep = "Select * from tb_reputation where service_name=\""
						+ name + "\";";
				ResultSet rRep = null;
				prepStmt = con.prepareStatement(sRep);
				rRep = prepStmt.executeQuery();
				while (rRep.next())
					c.setRules(Type.Reputation, rRep.getDouble(3), rRep
							.getString(4));

				// ɹʱ

				String sSucRate = "Select * from tb_successful_rate where service_name=\""
						+ name + "\";";
				ResultSet rSucRate = null;
				prepStmt = con.prepareStatement(sSucRate);
				rSucRate = prepStmt.executeQuery();
				while (rSucRate.next())
					c.setRules(Type.SuccessfulRate, rSucRate.getDouble(3),
							rSucRate.getString(4));

				list.add(c);
			}
		} catch (SQLException e) {
			throw new UDDIException(e);
		} finally {
			closeResultSet(rs);
			closePrepStmt(prepStmt);
			closeConnection(con);
		}
		
		return list;
	}
	
	public List<ICandidate> getCandidates(IService service) throws UDDIException{
		return getCandidates(service.getType(),service.getID());								
	}
/*	
	public List<ICandidate> getAllCandidates() throws UDDIException{
		List<ICandidate> list = new ArrayList<ICandidate>();
		Connection con=null;
		PreparedStatement prepStmt=null;
		ResultSet rs=null;
		String str="select * from tb_service_list;";
		con = getConnection();
		try {
			prepStmt = con.prepareStatement(str);
			rs = prepStmt.executeQuery();
			while (rs.next()) {
				String name = rs.getString(2);
				String serviceType = rs.getString(3);
				Candidate c = new Candidate(serviceType, name);
				String description = rs.getString(4);
				String[] descriptions = description.split(";");
				for (int i = 0; i < descriptions.length; i++) {
					String[] val = descriptions[i].split("=");
					c.attrMap.put(val[0], val[1]);
				}
				c.setRules(Type.Price, rs.getDouble(5), null);
				c.setRules(Type.ResponseTime, rs.getDouble(6), null);
				c.setRules(Type.Reputation, rs.getDouble(7), null);
				c.setRules(Type.SuccessfulRate, rs.getDouble(8), null);

				// Ҽ۸

				String sPrice = "Select * from tb_price where service_name=\""
						+ name + "\";";
				ResultSet rPrice = null;
				prepStmt = con.prepareStatement(sPrice);
				rPrice = prepStmt.executeQuery();
				while (rPrice.next())
					c.setRules(Type.Price, rPrice.getDouble(3), rPrice
							.getString(4));

				// ִʱ

				String sRTime = "Select * from tb_execute_time where service_name=\""
						+ name + "\";";
				ResultSet rRTime = null;
				prepStmt = con.prepareStatement(sRTime);
				rRTime = prepStmt.executeQuery();
				while (rRTime.next())
					c.setRules(Type.ResponseTime, rRTime.getDouble(3), rRTime
							.getString(4));

				// 

				String sRep = "Select * from tb_reputation where service_name=\""
						+ name + "\";";
				ResultSet rRep = null;
				prepStmt = con.prepareStatement(sRep);
				rRep = prepStmt.executeQuery();
				while (rRep.next())
					c.setRules(Type.Reputation, rRep.getDouble(3), rRep
							.getString(4));

				// ɹʱ

				String sSucRate = "Select * from tb_successful_rate where service_name=\""
						+ name + "\";";
				ResultSet rSucRate = null;
				prepStmt = con.prepareStatement(sSucRate);
				rSucRate = prepStmt.executeQuery();
				while (rSucRate.next())
					c.setRules(Type.SuccessfulRate, rSucRate.getDouble(3),
							rSucRate.getString(4));

				list.add(c);
			}
		} catch (SQLException e) {
			throw new UDDIException(e);
		} finally {
			closeResultSet(rs);
			closePrepStmt(prepStmt);
			closeConnection(con);
		}
		
		return list;
	}
*/
	@Override
	public String getCandidateType(String candidateName) throws UDDIException {
		Connection con=null;
		PreparedStatement prepStmt=null;
		ResultSet rs=null;
		
		String result = null;
		String str="select service_type from tb_service_list where service_name = \""+candidateName+"\";";
		try {
			con = getConnection();
			prepStmt = con.prepareStatement(str);
			rs = prepStmt.executeQuery();
			while (rs.next()) {
				result = rs.getString(1);
			}
		}catch (SQLException e) {
			throw new UDDIException(e);
		}
		return result;
	}

	@Override
	public String getCandidateWsdl(String candidateName)throws UDDIException {
		Connection con=null;
		PreparedStatement prepStmt=null;
		ResultSet rs=null;
		
		String result = null;
		String str="select wsdl_address from tb_service_list where service_name = \""+candidateName+"\";";
		try {
			con = getConnection();
			prepStmt = con.prepareStatement(str);
			rs = prepStmt.executeQuery();
			while (rs.next()) {
				result = rs.getString(1);
			}
		}catch (SQLException e) {
			throw new UDDIException(e);
		}
		return result;
	}
	
	public static void main(String[] args){
		File dbProperties = new File("./testfile/resource.properties");
		try {
			IUDDI uddi = new UDDI(dbProperties);
			String name = "Flight";
//			System.out.println(uddi.getCandidateType(name));
//			System.out.println(uddi.getCandidateWsdl(name));
			try {
				List<ICandidate> list = uddi.getCandidates(new Service("wxq_id","Flight"));
				for(ICandidate item:list){
					System.out.println(item.getName()+" "+ item.getServiceID()+" " + item.getWsdlAddr());
				}
				
			} catch (ServiceChoicerException e) {

				e.printStackTrace();
			}
			
			
		} catch (UDDIException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
