package org.once.serviceChoicer.input.process.impl;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.once.serviceChoicer.exception.ProcessException;
import org.once.serviceChoicer.input.process.IEPath;
import org.once.serviceChoicer.input.process.IProcess;
import org.once.serviceChoicer.input.process.IService;
import org.once.serviceChoicer.input.process.ISubPath;

public class Process implements IProcess{
	
	private Element lanes;
	private List<IEPath> ePathes; 
	private List<IService> services; 
	private Map<String,String> idTypeMap;
	
	
	public Process(File f,Map<String,String> idType) throws ProcessException{
		this.ePathes = new ArrayList<IEPath>();
		this.services = new ArrayList<IService>();
		idTypeMap = idType;
		parser(f);
	}
	public void generateProcess(){
		generateEPathes();
	}
	
	private void parser(File f) throws ProcessException {
		if (!f.exists()) {
			throw new ProcessException();
		} else {
			SAXReader read = new SAXReader();
			Document doc;
			try {
				doc = read.read(f);
			} catch (DocumentException e) {
				throw new ProcessException(e);
			}
			Element root = doc.getRootElement();
			Element e = root.element("pools");
			lanes = e.element("lanes");
		}

	}
	public List<IEPath> getEPathes() {
		return this.ePathes;
	}
	
	@Override
	public List<IService> getServices() {
		return services;
	}
	
	private void generateEPathes(){
		// TODO 
		Element Eroot=(Element)lanes.clone();
		Element Estart = null;	// ʼڵ
		for(Iterator i=Eroot.elementIterator();i.hasNext();){    
			 Element element=(Element) i.next();
			 String s=element.attributeValue("type");
//			 System.out.println(s);
			 
			 if(s.equals("bpmn:NoneStartEvent") 			// Ѱҿʼڵ
					 ||s.equals("bpmn:MessageStartEvent")
					 ||s.equals("bpmn:MutipleStartEvent")
					 ||s.equals("bpmn:RuleStartEvent")
					 ||s.equals("bpmn:TimerStartEvent"))
			 { 
				 Estart=(Element)element.clone();
//				 Eroot.remove(element);
//				 break;
			 }
			 // TODO ""ߡѭṹȡбӦôȡ	
			 // TODO WXQ  б
			 else{
				 getServiceList(element);
			 }
				
		}
		
		// TODO ļ:BPMNļһ߼ȷļûBPMNļ﷨
		// TODO ﷨Ӧû֮УȻѡķ
		
		if(Estart==null) // Ӧ÷ؿpath?ЩǱɵģʹǿյҲҪ
			return;
		
		// ҵ˿ʼڵ
		ePathes.addAll(getFollowingEPathes(Estart));
		
		
		// 
/*		List<ISubPath> subPaths=new ArrayList<ISubPath>();
		SubPath sub=new SubPath();
		subPaths.addAll(getFlow(Estart,sub));
//		System.out.println(subPaths);
		IEPath ePath = new EPath(subPaths, services, 1);
//		System.out.println(ePath);
		ePathes.add(ePath);
*/	
	}
	private void getServiceList(Element e) {
		String s=e.attributeValue("type");
		if(s.equals("bpmn:ServiceTask")){
			// ȡIDmapӦͣΪķ
			 String sID = e.attributeValue("id");
			 String name = idTypeMap.get(sID); 
			 IService service=new Service(sID, name);
			 services.add(service);
			 return ;
			 
		 }else if (s.equals("bpmn:EmbeddedSubProcess")){
			 for(Iterator i=e.elementIterator();i.hasNext();){
				 getServiceList((Element)i.next());
			 }
		 }
		
	}
	private List<IEPath> getFollowingEPathes(Element estart) 
	{
		List<IEPath> result = new ArrayList<IEPath>();
		
		List<IService> mainServices = new ArrayList<IService>();
		
		String type = null;
		String serviceId = null;
		
		// estartڵ㿪ʼ  
		for(;estart!=null; estart = getNext(estart)){
			type = estart.attributeValue("type");
			serviceId = estart.attributeValue("id");
			
			// Ƿ֧ڵ㣨֧Ͳз֧
			// TODO ǵ
			if(!type.equals("bpmn:DataExclusiveGateway")&&!type.equals("bpmn:EventExclusiveGateway")&&!type.equals("bpmn:ParallelGateway")){
				if(type.equals("bpmn:ServiceTask")){
					// IDͣΪ
					String sID = estart.attributeValue("id");
					IService service = new Service(sID,idTypeMap.get(sID));
					mainServices.add(service);
				}
			}else{
				break;
			}
		}
		
		if(estart == null){
			if(type.equals("bpmn:NoneEndEvent")
					||type.equals("bpmn:LingEndEvent")
					||type.equals("bpmn:MessageEndEvent")
					||type.equals("bpmn:MultipleEndEvent")
					||type.equals("bpmn:TerminateEndEvent")){	// Ľڵǽڵ,ȷ
				if(mainServices.size()>0){
					SubPath subPath = new SubPath();
					subPath.addList(mainServices);
					List<ISubPath> subPathes = new ArrayList<ISubPath>();
					subPathes.add(subPath);
					
					// TODO ePathִĬȡֵΪ1					
					result.add(new EPath(subPathes,mainServices,1));
					return result;
				}else{
					return result; // ؿյб,ʾ·ûserviceTask
				}
			}else{
				return null;	// ؿֵʾûȷePath
			}
		}
			
		
		if(type.equals("bpmn:DataExclusiveGateway")
				||type.equals("bpmn:EventExclusiveGateway")){
			
			List<Element> list = getNextList(estart);
			int num = 0;
			for(Element item :list){
				List<IEPath> following = getFollowingEPathes(item);
				if (following != null) {
					if(!following.isEmpty()){
						num++;
						for (IEPath followingEPath : following) {
							List<ISubPath> subPathes = new ArrayList<ISubPath>();
							// ѺsubpathеÿmainServiceӵsubPathesб
							for (ISubPath followingSubPath : followingEPath.getSubPathes()) {
								SubPath subPath = new SubPath();
								subPath.addList(mainServices);
								subPath.addList(followingSubPath.getServices());
								subPathes.add(subPath);
							}
							// Ѻ̵ķӵб
							List<IService> services = new ArrayList<IService>();
							services.addAll(mainServices);
							services.addAll(followingEPath.getServices());
							// µePath
							result.add(new EPath(subPathes, services, 1));
						}
					}
				}// flowingΪֵʾûȷ·
			}
			
			// ÿ·ĵִиʸֵ
			for(IEPath ePath:result){
				ePath.setProperty(1/(double)num);
			}
			return result;	
		}
		return null;
	}
	//ȡһڵ
	private Element getNext(Element e){
		if(e.attributeValue("type").equals("bpmn:SequenceFlow")){
			return null;
		}// ʼԪӦһڵ㣬һߡ
		
		// 
		String s=e.attributeValue("outcomingEdges");
		if(s==null)
			return null;
		// ڵ߲Ϊ
		
		String eTarget=null;
		
		// Ѱҵ
		for(Iterator i=lanes.elementIterator();i.hasNext();){
			 Element element=(Element) i.next();
			 if(!element.attributeValue("type").equals("bpmn:SequenceFlow"))
				 continue;
			 String id=element.attributeValue("id");
//			 System.out.println(id);
			 if(id.equals(s)){
				eTarget=element.attributeValue("target");
				break;
			 }
		}
		
		if(eTarget == null)
			return null;	// ûҵߣBPMN
		
		Element node = getNode(lanes.elementIterator(), eTarget);
		return node;
		
/*		for(Iterator i=lanes.elementIterator();i.hasNext();){
			Element element=(Element) i.next();
			if(!element.attributeValue("type").equals("bpmn:EmbeddedSubProcess")){
				String id=element.attributeValue("id");
				if(id.equals(eTarget)){
					return element;
				}
			}else{
				
			}
		}
		return null;
*/
	}
	
	private Element getNode(Iterator root, String target) {
		while(root.hasNext()){
			Element element=(Element) root.next();
			if(!element.attributeValue("type").equals("bpmn:EmbeddedSubProcess")){
				String id = element.attributeValue("id");
				if(id.equals(target)){
					return element;
				}
			}else{
				Element result = getNode(element.elementIterator(),target);
				if(result != null)
					return result;
			}
		}
		return null;
	}
	
	//ȡؽڵӽڵ
	private List<Element> getNextList(Element e){
		List<Element> eleList=new ArrayList<Element>();
		//todo
		String eTarget=null;
		String s=e.attributeValue("outcomingEdges");
		String[] outs=s.split(" ");
		for(int l=0;l<outs.length;l++){
			String out=outs[l];
			for(Iterator i=lanes.elementIterator();i.hasNext();){
				 Element element=(Element) i.next();
				 String id=element.attributeValue("id");
//				 System.out.println(id);
				 if(id.equals(out)){
					eTarget=element.attributeValue("target");
					break;
				 }
			}
			Element node = null;
			
			node = getNode(lanes.elementIterator(),eTarget);
			
			if(node!=null)
				eleList.add(node);
			/*for(Iterator i=lanes.elementIterator();i.hasNext();){
				Element element=(Element) i.next();
				if(element.attributeValue("id").equals(eTarget)){
					eleList.add(element);
					break;
				}
			}*/
		}
		return eleList;
		
	}
/*	//˳ִнڵ
	private List<SubPath> getFlow(Element e, SubPath sub){
		List<SubPath> list=new ArrayList<SubPath>();
		String s=e.attributeValue("type");
//		System.out.println(s);
		while(e!=null&&!s.equals("bpmn:ParallelGateway")){
			 if(s.equals("bpmn:ServiceTask")){
				 s=e.attributeValue("name");
				 sub.addService(new Service(s));
			 }//if
			 e=getNext(e);
			 if(e!=null)
				 s=e.attributeValue("type");
		}//while
		if(s.equals("bpmn:ParallelGateway")){
			List<SubPath> andList;
			andList=getAnd(e);
			for(int i=0;i<andList.size();i++){
				SubPath subPath=new SubPath();
				subPath.addList(sub.getServices());
				subPath.addList(andList.get(i).getServices());
				list.add(subPath);
			}
		}
		else
			list.add(sub);
		return list;
		
	}*/
	
	//Ľڵǡڵ㣬ݹ飬һlist
/*	private List<SubPath> getAnd(Element e){
		List<Element> eList=getNextList(e);
		List<SubPath> sList=new ArrayList<SubPath>();
		for(int i=0;i<eList.size();i++){
			SubPath sub=new SubPath(); 
//			List<SubPath> sublist=new ArrayList<SubPath>();
			e=eList.get(i);
			sList.addAll(getFlow(e, sub));
		}
		SubPath subPath=new SubPath();
		return sList;
	}*/
	
	public void test(){
		System.out.println(this.getEPathes().size());
		for(IService service:this.getServices()){
			System.out.print(service.getType()+"---"+service.getID());
		}
		System.out.println();
		
		int i = 0;
		for(IEPath epath:this.getEPathes())
		{
			i++;
			int j = 0;
			System.out.println(i+"th process:");
			System.out.println("ePathNo:" + epath.getPathNo());
			System.out.println("ִиʣ" + epath.getProbobility());
			System.out.print("б");
			for(IService s : epath.getServices() )
				System.out.print(s.getType());
			System.out.println();
			for(ISubPath subPath:epath.getSubPathes()){
				j++;
				System.out.println(j+"th subpathes:");
				for(IService service:subPath.getServices()){
					System.out.println(service.getType());
				}
			}
		}
	}
	
	public static void main(String[] args){
		
		File file = new File("./testfile/default.Bpmn");
		Map<String,String> map = new HashMap<String,String>();
		map.put("n112_3", "Login");
		map.put("n19_17", "Mountain");
		map.put("n178_0", "Mountain");
		map.put("n11_18","Island");
		map.put("n131_2","Island");
		map.put("n18_29","Hotel");
		map.put("n16_33","Hotel");
		map.put("n17_56","Flight");
		map.put("n16_57","Flight");
		map.put("n13_42","Pay");
		map.put("n18_43","Pay");
		
		try {
			Process process = new Process(file,map);
			process.generateProcess();
			process.test();
			/*System.out.println(process.getEPathes().size());
			int i = 0;
			for(IEPath epath:process.getEPathes())
			{
				i++;
				int j = 0;
				System.out.println(i+"th process:");
				for(ISubPath subPath:epath.getSubPathes()){
					j++;
					System.out.println(j+"th subpathes:");
					for(IService service:subPath.getServices()){
						System.out.println(service.getType());
					}
				}
			}*/
			
		} catch (ProcessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	
	}
}
