package org.once.serviceChoicer.input.qos.impl;

import java.util.ArrayList;
import java.util.List;

import org.once.serviceChoicer.exception.ServiceChoicerException;
import org.once.serviceChoicer.input.qos.IQoSAttr;
import org.once.serviceChoicer.input.qos.IQoSAttrs;
import org.once.serviceChoicer.input.qos.IQoSAttr.Type;

public class QoSAttrs implements IQoSAttrs{
	
	public static IQoSAttrs getDefInstance(){
		IQoSAttrs qos = new QoSAttrs();
		qos.addQoSAttr(new QoSAttr(Type.Price, 5000, 0, 0.5));
		qos.addQoSAttr(new QoSAttr(Type.ResponseTime,8000,0,0.3));
		qos.addQoSAttr(new QoSAttr(Type.SuccessfulRate,1,0.5,0.2));
		return qos;
	}
	
	private List<IQoSAttr> list = new ArrayList<IQoSAttr>();

	@Override
	public void addQoSAttr(IQoSAttr qosAttr) {
		list.add(qosAttr);
	}

	@Override
	public List<Type> getAttrTypes() {
		ArrayList<Type> typeList = new ArrayList<Type>();
		for(IQoSAttr item : this.list){
			typeList.add(item.getQoSAttrType());
		}
		return typeList;	
	}

	@Override
	public double getWeight(Type type) {
		for(IQoSAttr item : this.list){
			if(item.getQoSAttrType() == type)
				return item.getWeight();
		}
		return 0;
	}

	@Override
	public double getMAX(Type type) throws ServiceChoicerException {
		for(IQoSAttr item : this.list){
			if(item.getQoSAttrType() == type)
				return item.getMAX();
		}
		// TODO
		throw new ServiceChoicerException("No such type");
	}

	@Override
	public double getMIN(Type type) throws ServiceChoicerException {
		for(IQoSAttr item : this.list){
			if(item.getQoSAttrType() == type)
				return item.getMIN();
		}
		// TODO
		throw new ServiceChoicerException("No such type");
	}

	@Override
	public IQoSAttr get(Type type) throws ServiceChoicerException {
		for(IQoSAttr item : this.list){
			if(item.getQoSAttrType() == type){
				return item;
			}
		}
		throw new ServiceChoicerException();
	}
}
