package org.once.serviceChoicer.math.impl;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

import org.once.serviceChoicer.math.IVariable;

public class Monomial implements Cloneable{	// ʽɡӡ
	
	private ArrayList<AtomFactor> list;
	private double coef;
	
	public Monomial(IVariable v){
		list = new ArrayList<AtomFactor>();
		list.add(new AtomFactor(v));
		this.coef = 1;
	}
	
	public Monomial(double d){
		list = new ArrayList<AtomFactor>();
		this.coef = d;
	}
	
	public void multi(Monomial m){
		this.coef = this.coef * m.coef;
		for(int i = 0; i < m.list.size(); i++){
			this.multi(m.list.get(i));
		}
	}
	
	private void multi(AtomFactor a){
		boolean flag = false;
		for(int i = 0; i < this.list.size(); i++){
			if(list.get(i).canSame(a)){
				list.get(i).multi(a);
				flag = true;
			}
		}
		if(flag == false)
			this.list.add(a);
	}
	
	public void multiCoef(double c){
		this.coef = this.coef * c;
	}
	
	public String toString(){
		String result = "";
		
		if(this.coef == 0 )
			return "0";		
		
		if(this.coef>0){
			result = "+";
		}else{
			result = "-";
		}
		
		if(this.list.isEmpty()){
			result += new DecimalFormat("###0.0000#").format(Math.abs(this.coef));
		}else{
			if(Math.abs(this.coef)!= 1){
				result += new DecimalFormat("###0.0000#").format(Math.abs(this.coef));
				if(!this.list.isEmpty())
					result += "*";
			}
			for(int i = 0; i < this.list.size(); i++){
				result += this.list.get(i).toString();
			}
		}
		return result;
	}
	
	public Monomial clone(){
		Monomial obj = null;
		try {
			obj = (Monomial) super.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		obj.coef = this.coef;
		obj.list = new ArrayList<AtomFactor>();
		for(int i = 0 ; i < list.size(); i++){
			obj.list.add((AtomFactor)( list.get(i)).clone());
		}		
		return obj;	
	}
	
	public boolean isEmpty(){
		if(this == null || this.list == null)
			return true;
		else{
			for(int i = 0; i < this.list.size(); i++){
				if(!this.list.get(i).isEmpty())
					return false;
			}
			return true;
		}
		
	}

	public void add(Monomial monomial) {
		if(this.canUnit(monomial))
			this.coef = this.coef + monomial.coef;
		else{
			System.out.println("ERROR: can not unit this two monomial");
		}
		
	}

	public boolean canUnit(Monomial m) {
		if(this.list.size() != m.list.size())
			return false;
		
		int i,j;
		for(i = 0; i < this.list.size(); i++){
			for(j = 0; j < m.list.size(); j++){
				if(list.get(i).canSame(m.list.get(j)))
				break;
			}
			if(j == m.list.size())
				return false;
		}	
		return true;
	}

	public int uk() {
		if(this.coef == 0)
			return 0;
		else
			return this.list.size();
	}

	public void setVar(IVariable var) {
		this.list.clear();
		this.list.add(new AtomFactor(var));
	}

	public List<IVariable> getVarList() {
		ArrayList<IVariable> aList = new ArrayList<IVariable>();
		for(int i = 0; i < this.list.size(); i++){
			aList.add(this.list.get(i).getVar());
		}
		return aList;
	}
}
