package org.once.serviceChoicer.qosDescrip2.parser.impl;

import java.util.List;
import java.util.Stack;

import org.once.serviceChoicer.qosDescrip2.parser.abstr.ATokenParser4log;
import org.once.serviceChoicer.qosDescrip2.parser.impl.RelationTableTest4log.Relation;
import org.once.serviceChoicer.qosDescrip2.token.IToken;
import org.once.serviceChoicer.qosDescrip2.token.IToken4log;
import org.once.serviceChoicer.qosDescrip2.token.IToken4log.Type;
import org.once.serviceChoicer.qosDescrip2.token.impl.Token4log;



public class OperatorFirstAnalyzer {
	
	private StipulatTable4log sTable;
	private ATokenParser4log tokenParser;
	private RelationTableTest4log relationTable;
	
	private Stack<IToken4log> stack;
	
	public OperatorFirstAnalyzer(RelationTableTest4log relationTable, StipulatTable4log sTable, ATokenParser4log tokenParser){
		this.relationTable = relationTable;
		this.sTable = sTable;
		this.tokenParser = tokenParser; 	
//		this.stack = new Stack<IToken4log>();
	}
	
	
	public Object parse(String rRule){
		this.stack = new Stack<IToken4log>();
		// дʣɴջ
		List<IToken> tokenList = tokenParser.cutToken(rRule);
//		System.out.println(this.tokenList);
		
		// ȷ
		tokenList.add(new Token4log("$"));
		
		stack.push(new Token4log("$"));
		
		int i = 0;
		while(i < tokenList.size()){
			
			// ƽ
			while(i < tokenList.size() && goIn((IToken4log) tokenList.get(i)) == true){
				i++;
			}
			
			// 
			if(i == tokenList.size())
				break;
		
			// handler
			Stack<IToken4log> handler = goOut();
//			System.out.println("handler: " + handler);
			
			// ݹԼеķйԼͬʱִӦĶֵ
			stack.push(sTable.sipulate(handler));
		}
		return stack.get(1).getLAttrValue();
	}


	private boolean goIn(IToken4log token) {
		int num = stack.size()-1;
		while(num>0 && stack.get(num).getType() == Type.NON_FINAL){
			num --;
		}

		// $ƽʾԼ
		Relation r = relationTable.getRelation(stack.get(num), token);
		
		if(r == null){
			stack.push(token);
			return true;
		}
		
		if(r != Relation.GT) {
			stack.push(token);
			return true;
		}
		return false;
	}
	
	private Stack<IToken4log> goOut(){
		
		IToken4log fronter;
		Stack<IToken4log> handlerStack = new Stack<IToken4log>();
		
		// ջеһΪnon_finalԪfronter
		do{
			fronter = stack.pop();
			handlerStack.push(fronter);
		}while(fronter.getType()== Type.NON_FINAL);
		
		while(stack.lastElement().getType() == Type.NON_FINAL ||
				( stack.lastElement().getType() != Type.NON_FINAL && relationTable.getRelation(stack.lastElement(),fronter) != Relation.LT ))
		{
			IToken4log temp = stack.pop();
			handlerStack.push(temp);
			if(temp.getType() != Type.NON_FINAL){
				fronter = temp;
			}
		}
		return handlerStack;
	}	
}
