package org.once.serviceChoicer.qosDescrip2.parser.impl;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.once.serviceChoicer.candidate.ICandidate;
import org.once.serviceChoicer.candidate.impl.Candidate;
import org.once.serviceChoicer.qosDescrip2.QoSDescripUtil;
import org.once.serviceChoicer.qosDescrip2.parser.abstr.ATokenParser4log4qos;
import org.once.serviceChoicer.qosDescrip2.token.ILAttr4log;
import org.once.serviceChoicer.qosDescrip2.token.impl.LAttr4log4list;


public class TokenParser4QoS4List extends ATokenParser4log4qos {

	private List<ICandidate> candidates;
//	private IVarManager varManager;

	public TokenParser4QoS4List(List<ICandidate> candidates) {
		super(candidates);
		this.candidates = candidates;
	}

	@Override
	public ILAttr4log parse(String str) {
		Set<ICandidate> list = new HashSet<ICandidate>();
		QoSDescripUtil des = new QoSDescripUtil(str);
		int i;
		for (i = 0; i < candidates.size(); i++) {
			if (candidates.get(i).getType().equalsIgnoreCase(des.getCType())) {
				Candidate c = (Candidate) candidates.get(i);
				if (c.attrMap.containsKey(des.getCAttr())
						&& c.attrMap.get(des.getCAttr()).equalsIgnoreCase(
								des.getVal())) {
					list.add(c);
				}
			}
		}
/*		IPolynomial pn = null;
		if (list.size() > 0) {
			pn = new Polynomial(1);
			for (int num = 0; num < list.size(); num++) {
				pn.multi(new Polynomial(list.get(num)));
			}
		}*/
		if (list.isEmpty()){
			return null;
		}
		else{
			
			return new LAttr4log4list(list);
		}
	}

}
