package org.once.serviceChoicer.system.impl;

import org.once.serviceChoicer.exception.ServiceChoicerException;
import org.once.serviceChoicer.input.qos.IQoSAttrs;
import org.once.serviceChoicer.input.qos.IQoSAttr.Type;
import org.once.serviceChoicer.input.qos.impl.QoSAttrs;
import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.math.impl.Polynomial;
import org.once.serviceChoicer.output.IVarManager;
import org.once.serviceChoicer.output.impl.VarManager;
import org.once.serviceChoicer.system.ICaculModle;


/**
 * Ϸѡģ
 * ϷQOSֵΪQOSԵļȨ
 */

public class CompServiceQoS implements ICaculModle{
	
	private IQoSAttrs qosAttrs;
	private IVarManager varManager;
	
	public CompServiceQoS(IQoSAttrs qosAttrs, IVarManager varManager){
		this.qosAttrs = qosAttrs;
		this.varManager = varManager;
	}

	
	/**
	 * ԼȨ
	 */
	@Override
	public IPolynomial getPNomial() {
		IPolynomial pn = new Polynomial();
		for(Type type : this.qosAttrs.getAttrTypes())
		{
			if(qosAttrs.getWeight(type)!=0){
				IPolynomial item = new Polynomial(varManager.getVar(type,true)).multiCoef(qosAttrs.getWeight(type));
				pn = pn.add(item);
			}
		}
		return pn;
	}
	
	public static void main(String[] args){
		
		IQoSAttrs qos = QoSAttrs.getDefInstance();
		IVarManager vars = new VarManager();
		ICaculModle cs = new CompServiceQoS(qos,vars);
		
		try {
			System.out.println(cs.getPNomial());
		} catch (ServiceChoicerException e) {
			e.printStackTrace();
		}
	}
	
	
	
	
}
