package org.once.serviceChoicer.system.util;

import java.util.HashMap;
import java.util.Map;

import org.once.serviceChoicer.input.qos.IQoSAttr;
import org.once.serviceChoicer.input.qos.IQoSAttr.Type;
import org.once.serviceChoicer.system.util.IAggregation.OPType;

public class AggrTable implements IAggrTable{
	
	private Map<IQoSAttr.Type,IAggregation> map;
	
	public AggrTable(){
		
		IAggregation price = new Aggregation(OPType.SUM);
		IAggregation rtime = new Aggregation(OPType.MAX,OPType.SUM);
		IAggregation srate = new Aggregation(OPType.PRODUCT);
		
		map = new HashMap<IQoSAttr.Type,IAggregation>();
		map.put(IQoSAttr.Type.Price,price);
		map.put(IQoSAttr.Type.ResponseTime,rtime);
		map.put(IQoSAttr.Type.SuccessfulRate,srate);
	}

	public boolean isProduct(Type type) {
		IAggregation aggr = map.get(type);
		if(aggr.getEPathOp()== null)
			System.out.println("error");
		else{
			if(aggr.getSubPathOp() == null){
				if(aggr.getEPathOp() == OPType.PRODUCT)
					return true;
			}
			else{
				if((aggr.getEPathOp() == OPType.PRODUCT || aggr
						.getSubPathOp() == OPType.PRODUCT))
					return true;
			}
		}
		return false;
	}

	public  IAggregation getAggrOp(Type type) {
		return (IAggregation) this.map.get(type);
	}

	@Override
	public boolean isPositive(Type type){
		if(type == Type.Price || type == Type.ResponseTime)
			return false;
		else 
			return true;
	}

}
